
//#include <cstdlib>

#include "sectorParameters.h"
#include "mixedTools.h"

sectorParameters::sectorParameters() : parametersString_(NULL)
{
  geometry_= string("CIRCULAR");
  nCells_ = 0;
  lCell_ = 0.0;
  pc_ = 0.0;
  nbParam_ = 4;
  parametersString_ = new string[nbParam_+1];
}

string* sectorParameters::getParametersString() const 
{
  parametersString_[0] = mixedTools::intToString(nbParam_);
  parametersString_[1] = geometry_;
  parametersString_[2] = mixedTools::intToString(nCells_);
  parametersString_[3] = mixedTools::doubleToString(lCell_);
  parametersString_[4] = mixedTools::doubleToString(pc_);
  return parametersString_;
}

void sectorParameters::setParametersString(string* param)
{
  geometry_ = param[1].c_str();
  nCells_ = atoi(param[2].c_str());
  lCell_ = atof(param[3].c_str());
  pc_ = atof(param[4].c_str());
}

void sectorParameters::raz()
{
  geometry_= string("CIRCULAR");
  nCells_ = 0;
  lCell_ = 0.0;
  pc_ = 0.0;
}

string sectorParameters::FileOutputFlow() const
{
  ostringstream sortie;
  sortie<<" lattice "<<endl;
  sortie<<geometry_<<" "<<nCells_<<" "<<lCell_<<" "<<pc_<<endl;
  return sortie.str();  
}

void sectorParameters::FileInput(ifstream& ifs)
{
  ifs >> geometry_ >> nCells_ >> lCell_ >> pc_;
}

void sectorParameters::InputRep(UAPNode* root)
{
  UAPNode* node = root->addChild("lattice");
  node->addAttribute("name","global_lattice");
  node->addChild("geometry")->addAttribute("type",geometry_);
  string txt = "";
  txt = mixedTools::doubleToString(pc_);
  node->addChild("pc")->addAttribute("design",txt);

  node = root->addChild("sector");
  node->addAttribute("name","sect");
  txt = mixedTools::doubleToString(lCell_);
  node->addAttribute("length",txt);
  txt = mixedTools::intToString(nCells_);
  node->addAttribute("repeat",txt);
}

int sectorParameters::getNumberOfCells() const {
  return nCells_;
}

double sectorParameters::getCellLength() const {
  return lCell_;
}

double sectorParameters::getParticleMomentum() const {
  return pc_;
}


